----------------------------------------------------------------
-- Q8:
--   Return the publisher of an item with id attribute
--   value (I4).
-- Feature:
--   Loop name with FOR statement
----------------------------------------------------------------
-- function
CREATE FUNCTION db2_orig_get_publisher_id_by_item_id(item_id_in CHARACTER(10))
  RETURNS CHARACTER(10)
  NO EXTERNAL ACTION
F1: BEGIN ATOMIC
    DECLARE taupsm_result CHARACTER(10);
    FOR related AS
      SELECT item_id, publisher_id FROM item_publisher
    DO
      IF related.item_id = item_id_in
      THEN
        SET taupsm_result = related.publisher_id;
      END IF;
    END FOR;
    RETURN taupsm_result;
END
-- end

-- sql
SELECT *
  FROM publisher
  WHERE publisher_id = db2_orig_get_publisher_id_by_item_id(
      CAST('P4' AS CHARACTER(10)))
-- end


