-----------------------------------------------------------------
-- Q10:
--   List the item titles ordered alphabetically by publisher
--   name, with release date within a certain time period
--   (from 1990-01-01 to 1995-01-01)
-- Feature:
--   IF without CURSOR
-----------------------------------------------------------------
CREATE FUNCTION item_of_90s(rd DATE)
  RETURNS BOOLEAN
  READS SQL DATA
  LANGUAGE SQL
  BEGIN
    IF (rd >= '1990-01-01') AND (rd < '1995-01-01')
    THEN RETURN TRUE;
    ELSE RETURN FALSE;
    END IF;
  END;

SELECT i.title, p.name
  FROM publisher p, item i, item_publisher ip
  WHERE i.item_id = ip.item_id
    AND ip.publisher_id = p.publisher_id
    AND item_of_90s(i.date_of_release)
  ORDER BY p.name;

