----------------------------------------------------------------
-- Q9:
--   Return the ISBN of an item with id attribute value (I5)
-- Feature:
--   CALL procedure from function
----------------------------------------------------------------
CREATE PROCEDURE proc_get_isbn_with_item_id(
    IN item_id_in CHARACTER(10),
    OUT isbn_out CHARACTER VARYING(20))
  READS SQL DATA
  LANGUAGE SQL
  SET isbn_out =
        (SELECT i.isbn
           FROM item i
           WHERE i.item_id = item_id_in);

CREATE FUNCTION invoke_proc(item_id_in CHARACTER(10))
  RETURNS CHARACTER VARYING(20)
  READS SQL DATA
  LANGUAGE SQL
  BEGIN
    DECLARE taupsm_result CHARACTER VARYING(20);
    CALL proc_get_isbn_with_item_id(
        item_id_in, taupsm_result);
    RETURN taupsm_result;
  END;

SELECT i.isbn FROM item i WHERE i.isbn = invoke_proc('I5');

