----------------------------------------------------------------
-- Q2:
--   Find the title of the item which has matching author
--   first name (Ben).
-- Feature:
--   SET with SELECT single row
----------------------------------------------------------------
-- init
CREATE TABLE TS (time_point DATE)
-- end

-- init
CREATE VIEW db2_max_get_author_name_CP AS
    SELECT * FROM (SELECT ts1.time_point AS begin_time,
                          ts2.time_point AS end_time
                     FROM TS AS ts1, TS AS ts2
                     WHERE ts1.time_point < ts2.time_point AND
                       $TIME_PERIOD
                       NOT EXISTS(
                         SELECT time_point FROM TS
                           WHERE time_point > ts1.time_point AND
                             time_point < ts2.time_point)
                           ORDER BY ts1.time_point) AS X
-- end

-- function
CREATE FUNCTION db2_max_get_author_name(aid CHARACTER(10),
                                        begin_time_in DATE)
  RETURNS CHARACTER(50)
  READS SQL DATA
  LANGUAGE SQL
F1: BEGIN ATOMIC
    DECLARE fname CHARACTER(50);
    SET fname = (SELECT a.first_name FROM author a
                   WHERE a.author_id = aid AND
                     a.begin_time <= begin_time_in AND
                     begin_time_in < a.end_time);
    RETURN fname;
END
-- end

-- sql
INSERT INTO TS
  SELECT begin_time AS time_point FROM item
  UNION
  SELECT end_time AS time_point FROM item
  UNION
  SELECT begin_time AS time_point FROM item_author
  UNION
  SELECT end_time AS time_point FROM item_author
  UNION
  SELECT begin_time AS time_point FROM author
  UNION
  SELECT end_time AS time_point FROM author
-- end

-- sql
SELECT i.title, CP.begin_time, CP.end_time
  FROM item i, item_author ia, db2_max_get_author_name_CP CP
  WHERE i.id = ia.item_id AND
      db2_max_get_author_name(ia.author_id,
                              CP.begin_time) = 'Bai' AND
--      GREATEST(i.begin_time, CP.begin_time, CAST('2010-01-01' AS DATE)) <
--        LEAST(i.end_time, CP.end_time, CAST('2010-01-02' AS DATE))
    i.begin_time <= CP.begin_time AND
    CP.begin_time <= i.end_time AND
    ia.begin_time <= CP.begin_time AND
    CP.begin_time < ia.end_time
-- end

-- clean
DROP TABLE TS
-- end


