/**
 * 
 */
package cs.arizona.tau.xml;

/**
 * @author spjoshi
 *
 */
public interface IPhysicalAnnotationValidator {

	/**
	 * Given snapshot Schema, Temporal Annotation and Physical Annotations, checks the consistency between them.
	 * The consistency could be checked from various point of views
	 * 1) Physical Annotation should be a valid instance of PXShema which could be checked using conventional validator.  
	 * 2) Whether the targets in given Physical Annotation are consistent with given snapshot schema.
	 * 3) At least one element above topmost target in temporal annotation has been timestamped.    
	 */
	public boolean validatePhysicalAnnotation();
	
}
